<template>
    <div
        v-for="(row, i) in computedFields"
        :key="`auto-form-${i}`"
    >
        <div
            v-if="row.type === 'text' || row.type === 'email' || row.type === 'number'"
            class="mb-4"
        >
            <component
                :is="FormInput"
                v-bind="row"
                :model-value="formData.get(row.name) || ''"
                :errors="errors[row.name]"
                @update:model-value="newValue => rowChanged(newValue, row)"
            />
        </div>
        <div
            v-else-if="row.type === 'editor'"
            class="mb-4"
        >
            <component
                :is="FormEditor"
                v-bind="row"
                :model-value="formData.get(row.name) || ''"
                :errors="errors[row.name]"
                @update:model-value="newValue => rowChanged(newValue, row)"
            />
        </div>
        <div
            v-else-if="row.type === 'time'"
            class="mb-4"
        >
            <component
                :is="FormTime"
                v-bind="row"
                :model-value="formData.get(row.name) || ''"
                :errors="errors[row.name]"
                @update:model-value="newValue => rowChanged(newValue, row)"
            />
        </div>
        <div
            v-else-if="row.type === 'date'"
            class="mb-4"
        >
            <component
                :is="FormDate"
                v-bind="row"
                :model-value="formData.get(row.name) || ''"
                :errors="errors[row.name]"
                @update:model-value="newValue => rowChanged(newValue, row)"
            />
        </div>
        <div
            v-else-if="row.type === 'textarea'"
            class="mb-4"
        >
            <component
                :is="FormTextArea"
                v-bind="row"
                :model-value="formData.get(row.name) || ''"
                :errors="errors[row.name]"
                @update:model-value="newValue => rowChanged(newValue, row)"
            />
        </div>
        <div
            v-else-if="row.type === 'password'"
            class="mb-4"
        >
            <component
                :is="FormPassword"
                v-bind="row"
                :model-value="formData.get(row.name) || ''"
                :errors="errors[row.name]"
                @update:model-value="newValue => rowChanged(newValue, row)"
            />
        </div>
        <div
            v-else-if="row.type === 'file'"
            class="mb-4"
        >
            <component
                :is="FormFile"
                v-bind="row"
                :model-value="formData.get(row.name) || ''"
                :errors="errors[row.name]"
                @update:model-value="newValue => rowChanged(newValue, row)"
            />
        </div>
        <div
            v-else-if="row.type === 'select'"
            class="mb-4"
        >
            <component
                :is="FormSelect"
                v-bind="row"
                :model-value="formData.get(row.name) || ''"
                :errors="errors[row.name]"
                @update:model-value="newValue => rowChanged(newValue, row)"
            />
        </div>
        <div
            v-else-if="row.type === 'checkbox'"
            class="mb-4"
        >
            <component
                :is="FormCheckbox"
                v-bind="row"
                :model-value="row.multiple ? (formData.getAll(row.name) || []) : (formData.get(row.name) || '')"
                :errors="errors[row.name]"
                @update:model-value="newValue => rowChanged(newValue, row)"
            />
        </div>
        <div
            v-else-if="row.type === 'contact'"
            class="mb-4"
        >
            <component
                :is="FormContact"
                v-bind="row"
                :select-value="formData.get(row.contactCountryName)"
                :input-value="formData.get(row.contactNumberName)"
                :errors="errors"
                @update:select-value="newValue => rowChanged(newValue, row, 'select')"
                @update:input-value="newValue => rowChanged(newValue, row, 'input')"
            />
        </div>
        <div
            v-else-if="row.type === 'pin'"
            class="mb-4"
        >
            <component
                :is="FormPin"
                v-bind="row"
                :model-value="formData.get(row.name) || ''"
                :errors="errors[row.name]"
                @update:model-value="newValue => rowChanged(newValue, row)"
            />
        </div>
    </div>
</template>

<script setup>
import {computed, inject, onMounted, ref} from "vue";
import axios from "axios";
import FormDate from './form/form-datepicker.vue';
import FormTime from './form/form-timepicker.vue';
import FormTextarea from './form/form-textarea.vue';
import FormEditor from './form/form-editor.vue';
import FormInput from './form/form-input.vue';
import FormPassword from './form/form-password.vue';
import FormFile from './form/form-file.vue';
import FormSelect from './form/form-select.vue';
import FormCheckbox from './form/form-checkbox.vue';
import FormContact from './form/form-contact.vue';
import FormTextArea from './form/form-textarea.vue';
import FormPin from './form/form-pin.vue';
const props = defineProps({
    fields: {
        required: true,
        type: Array,
    },
    defaultData: {
        required: false,
        type: Object,
        default: () => {
            return {};
        },
    },
    hiddenData: {
        required: false,
        type: Object,
        default: () => {
            return {};
        },
    }
});

const emit = defineEmits(['form-update']);
const $helper = inject('$helper');

const formData = new FormData();
const errors = ref({});
const busy = ref(false);

const computedFields = computed(() => {
    return props.fields.map(r => {
        if (r.type === 'contact') {
            return {
                ...r,
                contactCountryName: r.contactCountryName ?? 'contact_country_id',
                contactNumberName: r.contactNumberName ?? 'contact_number',
            }
        } else {
            return r;
        }
    });
});

computedFields.value.forEach(r => {
    if (r.type === 'contact') {
        formData.set(r.contactCountryName, props.defaultData[r.contactCountryName] || '');
        formData.set(r.contactNumberName, props.defaultData[r.contactNumberName] || '');
    } else if (r.type === 'checkbox' && r.multiple) {
        if (typeof props.defaultData[r.name] && Array.isArray(props.defaultData[r.name])) {
            props.defaultData[r.name].forEach(dr => {
                formData.append(r.name, String(dr));
            });
        }
    } else if ((r.type === 'file' && !r.multiple) || r.type !== 'file') {
        formData.set(r.name, props.defaultData[r.name] || '');
    }
});

Object.keys(props.hiddenData).forEach(r => {
    formData.set(r, props.hiddenData[r]);
});

const getFormData = () => {
    return formData;
};

const rowChanged = (newValue, row, contactField) => {
    if (row.type === 'editor') {
        formData.set(row.name, JSON.stringify(newValue));
    } else if (row.type === 'file') {
        if (newValue instanceof File) {
            formData.set(row.name, newValue);
        } else if (newValue instanceof FileList) {
            [...newValue].forEach(file => {
                formData.append(row.name, file);
            });
        } else {
            formData.delete(row.name);
        }
    } else if (row.type === 'contact') {
        if (contactField === 'select') {
            formData.set(row.contactCountryName, String(newValue));
        } else if (contactField === 'input') {
            formData.set(row.contactNumberName, String(newValue));
        }
    } else {
        if (Array.isArray(newValue)) {
            formData.delete(row.name);
            newValue.forEach(r => {
                formData.append(row.name, r);
            });
        } else {
            formData.set(row.name, String(newValue));
        }
    }

    //CLEAR ERROR
    if (row.type === 'contact') {
        if (contactField === 'select') {
            errors.value[row.contactCountryName] = [];
        } else if (contactField === 'input') {
            errors.value[row.contactNumberName] = [];
        }
    } else {
        errors.value[row.name] = [];
    }

    emit('form-update', formData);
};

const submitForm = async (url) => {
    try {
        busy.value = true;
        return await axios.post(url, formData);
    } catch (error) {
        if (error.response.data.errors) {
            errors.value = error.response.data.errors;
        } else if (error.response) {
            // Request made and server responded
            console.log(error.response.data);
            console.log(error.response.status);
            console.log(error.response.headers);
        } else if (error.request) {
            // The request was made but no response was received
            console.log(error.request);
        } else {
            console.log(error);
            await $helper.alertError({message: error.message});
        }
        return Promise.reject(error);
    } finally {
        busy.value = false;
    }
};

defineExpose({
    FormDate,
    FormTime,
    FormInput,
    FormTextarea,
    FormEditor,
    FormPassword,
    FormFile,
    FormSelect,
    FormCheckbox,
    FormContact,
    FormTextArea,
    FormPin,
    computedFields,
    formData,
    busy,
    rowChanged,
    getFormData,
    submitForm,
});
</script>
